Package com.saxonica.config

## Class JavaExtensionLibrary

- java.lang.Object
- - com.saxonica.config.JavaExtensionLibrary

- All Implemented Interfaces:
    `FunctionLibrary`

      public class JavaExtensionLibrary
      extends java.lang.Object
      implements FunctionLibrary

  The JavaExtensionLibrary is a FunctionLibrary that binds XPath function calls to calls on Java methods (or constructors, or fields). It performs a mapping from the namespace URI of the function to the Java class (the mapping is partly table driven and partly algorithmic), and maps the local name of the function to the Java method, constructor, or field within the class. If the Java methods are polymorphic, then it tries to select the appropriate method based on the static types of the supplied arguments. Binding is done entirely at XPath compilation time.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `JavaExtensionLibrary.UnresolvedExtensionFunctionCall` | Inner class representing an unresolved extension function call.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `JavaExtensionLibrary​(ProfessionalConfiguration config)` | Construct a JavaExtensionLibrary and establish the default uri->class mappings.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected int` | `atomicConversionPreference​(int primitiveType, java.lang.Class<?> required)` | Get the conversion preference from an XPath primitive atomic type to a Java class
    `Expression` | `bind​(SymbolicName.F symbolicName, Expression[] staticArgs, StaticContext env, java.util.List<java.lang.String> reasons)` | Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
    `FunctionLibrary` | `copy()` | This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
    `void` | `declareJavaClass​(java.lang.String uri, java.lang.Class theClass)` | Declare a mapping from a specific namespace URI to a Java class
    `JavaExtensionFunctionFactory` | `getExtensionFunctionFactory()` | Get the ExtensionFunctionFactory used by this extension library.
    `protected java.lang.Class` | `getExternalJavaClass​(java.lang.String uri, java.lang.String localName, boolean debug)` | Get an external Java class corresponding to a given namespace URI, if there is one.
    `Function` | `getFunctionItem​(SymbolicName.F functionName, StaticContext staticContext)` | Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.
    `protected java.lang.String` | `getMethodNameFromLocalName​(java.lang.String uri, java.lang.String localName, boolean debug)` | Get the Java method/field name from the local name used in the function call.
    `boolean` | `isAvailable​(SymbolicName.F functionName)` | Test whether a function with a given name and arity is available
    `boolean` | `isStrictJavaUriFormat()` | Ask whether only the strict "java:" URI format is to be recognized.
    `void` | `setExtensionFunctionFactory​(JavaExtensionFunctionFactory factory)` | Set the ExtensionFunctionFactory to be used by this extension library.
    `void` | `setStrictJavaUriFormat​(boolean strict)` | Say that only the strict "java:" URI format is to be recognized.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.functions.FunctionLibrary

      `setConfiguration`

- - ### Constructor Detail

    - #### JavaExtensionLibrary

          public JavaExtensionLibrary​(ProfessionalConfiguration config)

      Construct a JavaExtensionLibrary and establish the default uri->class mappings.
      Parameters:
        `config` - The Saxon configuration

  - ### Method Detail

    - #### setExtensionFunctionFactory

          public void setExtensionFunctionFactory​(JavaExtensionFunctionFactory factory)

      Set the ExtensionFunctionFactory to be used by this extension library.
      Parameters:
        `factory` - This must be an instanceof JavaExtensionFunctionFactory

    - #### getExtensionFunctionFactory

          public JavaExtensionFunctionFactory getExtensionFunctionFactory()

      Get the ExtensionFunctionFactory used by this extension library.
      Returns:
        the factory, which will always be an instanceof JavaExtensionFunctionFactory

    - #### isStrictJavaUriFormat

          public boolean isStrictJavaUriFormat()

      Ask whether only the strict "java:" URI format is to be recognized. The default is "true": the value false can be set for backwards compatibility with releases before Saxon 9.2
      Returns:
        true if only the strict format is recognized

    - #### setStrictJavaUriFormat

          public void setStrictJavaUriFormat​(boolean strict)

      Say that only the strict "java:" URI format is to be recognized. The default is "true": the value false can be set for backwards compatibility with releases before Saxon 9.2
      Parameters:
        `strict` - true if only the strict format is recognized

    - #### declareJavaClass

          public void declareJavaClass​(java.lang.String uri,
                                       java.lang.Class theClass)

      Declare a mapping from a specific namespace URI to a Java class
      Parameters:
        `uri` - the namespace URI of the function name
        `theClass` - the Java class that implements the functions in this namespace

    - #### getFunctionItem

          public Function getFunctionItem​(SymbolicName.F functionName,
                                          StaticContext staticContext)
                                   throws XPathException

      Test whether a function with a given name and arity is available; if so, return a function item that can be dynamically called.

      This supports the function-lookup() function in XPath 3.0.

      Specified by:
        `getFunctionItem` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
        `staticContext` - the static context to be used by the function, in the event that it is a system function with dependencies on the static context
      Returns:
        if a function of this name and arity is available for calling, then a corresponding function item; or null if the function does not exist
      Throws:
        `XPathException` - in the event of certain errors, for example attempting to get a function that is private

    - #### isAvailable

          public boolean isAvailable​(SymbolicName.F functionName)

      Test whether a function with a given name and arity is available

      This supports the function-available() function in XSLT.

      Specified by:
        `isAvailable` in interface `FunctionLibrary`
      Parameters:
        `functionName` - the qualified name of the function being called
      Returns:
        true if a function of this name and arity is available for calling

    - #### bind

          public Expression bind​(SymbolicName.F symbolicName,
                                 Expression[] staticArgs,
                                 StaticContext env,
                                 java.util.List<java.lang.String> reasons)

      Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.
      Specified by:
        `bind` in interface `FunctionLibrary`
      Parameters:
        `symbolicName` - the qualified name and arity of the function being called
        `staticArgs` - The expressions supplied statically in the function call. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality()) may be used as part of the binding algorithm.
        `env` - the static context
        `reasons` - If no matching function is found by the function library, it may add a diagnostic explanation to this list explaining why none of the available functions could be used.
      Returns:
        An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name, arity, or signature.

    - #### atomicConversionPreference

          protected int atomicConversionPreference​(int primitiveType,
                                                   java.lang.Class<?> required)

      Get the conversion preference from an XPath primitive atomic type to a Java class
      Parameters:
        `primitiveType` - integer code identifying the XPath primitive type, for example `StandardNames.XS_STRING` or `StandardNames.XS_STRING`
        `required` - The Java Class named in the method signature
      Returns:
        an integer indicating the relative preference for converting this primitive type to this Java class. A high number indicates a low preference. All values are in the range 50 to 100. For example, the conversion of an XPath String to `StringValue` is 50, while XPath String to `String` is 51. The value -1 indicates that the conversion is not allowed.

    - #### getExternalJavaClass

          protected java.lang.Class getExternalJavaClass​(java.lang.String uri,
                                                         java.lang.String localName,
                                                         boolean debug)

      Get an external Java class corresponding to a given namespace URI, if there is one. The method is protected so it can be overridden in a user-defined subclass.
      Parameters:
        `uri` - The namespace URI corresponding to the prefix used in the function call.
        `localName` - The local name of the function, in case this contributes to determining the class
        `debug` - true if tracing information should be output
      Returns:
        the Java class name if a suitable class exists, otherwise return null.

    - #### getMethodNameFromLocalName

          protected java.lang.String getMethodNameFromLocalName​(java.lang.String uri,
                                                                java.lang.String localName,
                                                                boolean debug)

      Get the Java method/field name from the local name used in the function call. This may be overridden in a subclass. The default implementation is as follows: if the URI is NamespaceConstant.JAVA_TYPE, the method name is that part of the local name appearing after the last dot/period. Otherwise, it is the local-name, converted to camel-case by removing hyphens and converting any character immediately following a hyphen to upper case.
      Parameters:
        `uri` - the namespace URI used in the function call
        `localName` - the local name used in the function call
        `debug` - true if tracing is requested
      Returns:
        the local name of the method or field

    - #### copy

          public FunctionLibrary copy()

      This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
      Specified by:
        `copy` in interface `FunctionLibrary`
      Returns:
        a copy of this function library. This must be an instance of the original class.